//
// MSVC Decoder
//
// Java Version 2021
//

public class Msvc{

	public static int bytes_to_int(byte a,byte b){
		int ta = a;
		if (ta<0){ta+=256;}
		int tb = b;
		if (tb<0){tb+=256;}
		
		return ta + (tb << 8);
	}

	// // 16bit to 24bit
	// private int gbyte(int col){
		// int r=(col & 0x7c00)>>7;
		// int g=(col & 0x03e0)>>2;
		// int b=(col & 0x001f)<<3;
		
		// int outcol=(0xff<<24)+(r<<16)+(g<<8)+(b & 0xff);
		
		// return outcol;
	// }


	// 16bit to 24bit to 8bit (gray)
	private byte gbyte(int col){
		 int r=((col & 0x7c00)>>10)<<3;
		 int g=((col & 0x03e0)>>5)<<3;
		 int b=(col & 0x001f)<<3;
		
		return (byte)((r+g+b)/3); //outcol;
	}


	//  cram8c#
	private void cram8c1(byte[] rgb,int off,byte clr,int rdec){
		for(int j=0;j<4;j++){
			rgb[off+0]=clr;
			rgb[off+1]=clr;
			rgb[off+2]=clr;
			rgb[off+3]=clr;
			off+=rdec;
		}
	}

	private void cram8c2(byte[] rgb,int off,byte flag,int cA,int cB,int rdec){
		byte realcb=gbyte(cB);
		byte realca=gbyte(cA);

		rgb[off+0]=(flag & 0x01)==0x01 ? (realcb) : (realca);
		rgb[off+1]=(flag & 0x02)==0x02 ? (realcb) : (realca);
		rgb[off+2]=(flag & 0x04)==0x04 ? (realcb) : (realca);
		rgb[off+3]=(flag & 0x08)==0x08 ? (realcb) : (realca);
		off=off-rdec;
		rgb[off+0]=(flag & 0x10)==0x10 ? (realcb) : (realca);
		rgb[off+1]=(flag & 0x20)==0x20 ? (realcb) : (realca);
		rgb[off+2]=(flag & 0x40)==0x40 ? (realcb) : (realca);
		rgb[off+3]=(flag & 0x80)==0x80 ? (realcb) : (realca);
	}

	private void cram8c4(byte[] rgb,int off, byte flag, int cA0,int cA1, int cB0,int cB1,int rowDec){
		byte a0=gbyte(cA0);
		byte a1=gbyte(cA1);
		byte b0=gbyte(cB0);
		byte b1=gbyte(cB1);

		rgb[off+0]=(flag & 0x01)==0x01 ? (b0) : (a0);
		rgb[off+1]=(flag & 0x02)==0x02 ? (b0) : (a0);
		rgb[off+2]=(flag & 0x04)==0x04 ? (b1) : (a1);
		rgb[off+3]=(flag & 0x08)==0x08 ? (b1) : (a1);
		off=off-rowDec;
		rgb[off+0]=(flag & 0x10)==0x10 ? (b0) : (a0);
		rgb[off+1]=(flag & 0x20)==0x20 ? (b0) : (a0);
		rgb[off+2]=(flag & 0x40)==0x40 ? (b1) : (a1);
		rgb[off+3]=(flag & 0x80)==0x80 ? (b1) : (a1);
	}


	public void decode(byte[] from,byte[] to,int width, int height){
		int encSize=from.Length;
		
		int pos=0,offset;
		int ca,cb,cc,cd,caz;
		byte code0,code1;
		int scode0,scode1;
		int xp=0;
		int yp=height-1;

		while(true){
			code0=from[0+pos];
			code1=from[1+pos];
			
			scode0=code0;
			scode1=code1;
			if (scode0<0){scode0+=256;}
			if (scode1<0){scode1+=256;}
			
			pos+=2;

			if ((scode1>=0x84) && (scode1<=0x87)){
				int skip=((scode1-0x84)<<8)+scode0;

				while(skip>0){
					skip--;
					xp+=4;
					if(xp>=width){yp-=4;xp=0;}
				}
			}else{
				if (scode1<0x80){
					ca=bytes_to_int(from[pos+0],from[pos+1]); 
					cb=bytes_to_int(from[pos+2],from[pos+3]); 

					if ((ca & 0x8000)==0x8000){
						cc=bytes_to_int(from[pos+4],from[pos+5]); 
						cd=bytes_to_int(from[pos+6],from[pos+7]); 

						offset=(yp*width)+xp;
						cram8c4(to,offset,code0,cb,cd,ca,cc,width);

						ca=bytes_to_int(from[pos+8],from[pos+9]); 
						cb=bytes_to_int(from[pos+10],from[pos+11]); 

						cc=bytes_to_int(from[pos+12],from[pos+13]); 
						cd=bytes_to_int(from[pos+14],from[pos+15]); 

						offset=((yp-2)*width)+xp;
						cram8c4(to,offset,code1,cb,cd,ca,cc,width);

						pos+=12;
					}else{
						offset=(yp*width)+xp;
						cram8c2(to,offset,code0,cb,ca,width);

						offset=((yp-2)*width)+xp;
						cram8c2(to,offset,code1,cb,ca,width);
					}					
					pos+=4;
				}else{
					caz=(scode1<<8)+scode0;
					byte clr=gbyte(caz);
					
					offset=((yp-3)*width)+xp;
					cram8c1(to,offset,clr,width);
				}
				
				xp+=4;
				if(xp>=width){yp-=4;xp=0;}
			}
			
			if (pos>=encSize || yp<0) { break;}
		}
	}

}